#ifndef lint
static char *rcsid = "$Header: /usr/src/local/awl/RCS/awl_driver.c,v 2.2 90/04/19 20:04:37 jkh Exp $";
#endif

/*
 *
 *                   Copyright 1989, 1990
 *                    Jordan K. Hubbard
 *
 *		  PCS Computer Systeme, GmbH.
 *	             Munich, West Germany
 *
 *
 *  All rights reserved.
 * 
 *  This is unsupported software and is subject to change without notice.
 *  the author makes no representations about the suitability of this software
 *  for any purpose. It is supplied "as is" without express or implied
 *  warranty.
 * 
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of the author not be used in
 *  advertising or publicity pertaining to distribution of the software
 *  without specific, written prior permission.
 *
 */

/*
 * This file implements the awl driver.
 *
 * $Log:	awl_driver.c,v $
 * Revision 2.2  90/04/19  20:04:37  jkh
 * Alpha checkin.
 * 
 * Revision 2.1  90/04/02  01:50:45  jkh
 * Changed the name to protect the innocent.
 * 
 * Revision 2.0  90/03/26  01:42:55  jkh
 * pre-beta check-in
 *
 */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
/* #include <Awl.h> */
#include "Awl.h"

static XrmOptionDescRec opts[] = {
     {"-cpp",		"*cppCommand",	XrmoptionSepArg, XgDefaultCppCommand},
     {"-cpparg",	"*cppArg",	XrmoptionSepArg, " "},
     {"-debug",		"*debug",	XrmoptionNoArg, "on" },
     {"-file",		"*file",	XrmoptionSepArg, NULL},
     {"-line",		"*line",	XrmoptionNoArg, "on" },
     {"-nowarn",	"*nowarn",	XrmoptionNoArg, "on" },
     {"-show",		"*show",	XrmoptionNoArg, "on" },
     {"-start",		"*start",	XrmoptionSepArg, "main"},
     {"-trace",		"*trace",	XrmoptionNoArg, "on" },
     {"-v",		"*version",	XrmoptionNoArg, "on" },
};

int main(argc, argv)
int argc;
char **argv;
{
     char **margv;
     Arg args[5];
     Cardinal i, ac, margc;
     Widget top;
     char cpp_args[1024];
     XtAppContext awl;
     String file = NULL;
     Display *dpy;

     /* Init the toolkit */
     XtToolkitInitialize();

     /* Get a unique application context */
     awl = XtCreateApplicationContext();

     /* Open the display (of course) */
     dpy = XtOpenDisplay(awl, NULL, "awl", "Awl", opts, XtNumber(opts),
			 &argc, argv);

     /* allocate margv for worst-case argument passing */
     margv = (char **)XtMalloc(sizeof(char **) * argc);
     margc = 1;


     /*
      * Assume that the first non -'d argument is the input file and any
      * other options are for the pre-processor. This lets us get around
      * having to use the klunky -file arg unconditionally. If we need to
      * pass some strange non -'d pre-processor args, we can always use -file.
      */
     strcpy(cpp_args, " ");
     for (ac = 1; ac < argc; ac++) {
	  if (argv[ac][0] != '-') {
	       if (!file)
		    file = argv[ac];
	       else
		    margv[margc++] = argv[ac];
	  }
	  else
	       strcat(cpp_args, argv[ac]);
     }

     i = 0;
     if (file) {
	  XtSetArg(args[i], XgNfile, file);		i++;
	  margv[0] = file;
     }
     else
	  margv[0] = "<stdin>";
     margv[margc] = NULL;
     if (margc > 1) {
	  XtSetArg(args[i], XgNmainArgv, margv);		i++;
     }
     XtSetArg(args[i], XgNcppArg, cpp_args);		i++;
     top = XtAppCreateShell("awl", "Awl", awlWidgetClass, dpy, args, i);
     XtAppMainLoop(awl);
     return(0);
}
