#ifndef lint
static char *rcsid = "$Header: /usr1/src/local/awl/RCS/strftime.c,v 1.1 90/04/21 23:12:20 jkh Exp $";
#endif

/* Copyright (C) 1990 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   
   The GNU C Library is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.
   
   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with the GNU C Library; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/*
 * Made some changes to remove inter-GNU dependencies that I don't have access
 * to yet (when the GNU C library is released, I can go that route instead)
 * and edited to conform to the overall awl style. Since this has to be
 * included with AWL for now (and the whole thing's under the GPL anyway), I
 * figured that it would be better to keep everything in sync. I've done the
 * same with regex.[ch].
 *
 * Jordan Hubbard
 *
 * $Log:	strftime.c,v $
 * Revision 1.1  90/04/21  23:12:20  jkh
 * Initial revision
 * 
 *
 */

#include "AwlP.h"

/* These I had to add myself. Not very international, I'm afraid. -jkh */
Local String A_wkday[] = {
     "Sun", "Mon", "Tue", "Wed","Thu", "Fri", "Sat",
};

Local String F_wkday[] = {
     "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday",
     "Saturday",
};

Local String A_month[] = {
     "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct",
     "Nov", "Dec",
};

Local String F_month[] = {
     "January", "February", "March","April", "May", "June", "July",
     "August", "September", "October", "November", "December",
};

Local String AP[] = {
     "AM", "PM",
};

#define	add(n, f)		\
     do {			\
	 i += (n);		\
	 if (i >= maxsize)	\
	      return 0;		\
	 else if (p != NULL) {  \
		   f;		\
		   p += (n);	\
	      }			\
     } while (0)

#define	cpy(n, s)	add((n), memcpy((Generic) p, (Generic) (s), (n)))
#define	fmt(n, args)	add((n), if (sprintf args != (n)) return 0)

/*
 * Return the week in the year specified by TP,
 * with weeks starting on STARTING_DAY.
 */
Local unsigned int week(tp, starting_day)
struct tm *tp;
int starting_day;
{
     int wday, dl;
     
     wday = tp->tm_wday - starting_day;
     if (wday < 0)
	  wday += 7;
     
     /*
      * Set DL to the day in the year of the last day of the week previous
      * to the one containing the day specified in TP. If DL is negative or
      * zero, the day specified in TP is in the first week of the year.
      * Otherwise, calculate the number of complete weeks before our week
      * (DL / 7) and add any partial week at the start of the year (DL % 7).
      */
     dl = tp->tm_yday - wday;
     return dl <= 0 ? 0 : ((dl / 7) + ((dl % 7) == 0 ? 0 : 1));
}

/*
 * Write information from TP into S according to the format
 * string FORMAT, writing no more that MAXSIZE characters
 * (including the terminating '\0') and returning number of
 * characters written.  If S is NULL, nothing will be written
 * anywhere, so to determine how many characters would be
 * written, use NULL for S and (int UINT_MAX for MAXSIZE.
 */
int strftime(s, maxsize, format, tp)
char *s;
int maxsize;
char *format;
register struct tm *tp;
{
     char *a_wkday = A_wkday[tp->tm_wday];
     char *f_wkday = F_wkday[tp->tm_wday];
     char *a_month = A_month[tp->tm_mon];
     char *f_month = F_month[tp->tm_mon];
     int aw_len = strlen(a_wkday);
     int am_len = strlen(a_month);
     int wkday_len = strlen(f_wkday);
     int month_len = strlen(f_month);
     int hour12 = tp->tm_hour;
     char *ampm = AP[hour12 > 12];
     int ap_len = strlen(ampm);
     unsigned int y_week0 = week(tp, 0);
     unsigned int y_week1 = week(tp, 1);
     char *zone;
     int zonelen;
     register int i = 0;
     register char *p = s;
     register char *f;
     
     if (tp->tm_isdst < 0) {
	  zone = "";
	  zonelen = 0;
     }
     else {
#ifdef SYSV	/* I think tzname is SYSV only */
	  zone = tzname[tp->tm_isdst];
#else
	  zone = "BSD";	/* be cute in the face of failure */
#endif
	  zonelen = strlen(zone);
     }
     
     if (hour12 > 12)
	  hour12 -= 12;
     else if (hour12 == 0)
	  hour12 = 12;
     
     for (f = format; *f != '\0'; ++f) {
	  char *subfmt;
	  
	  if (!isascii(*f)) {
	       /* Non-ASCII, may be a multibyte. (ho ho. Ahem. PUNT -jkh) */
	       /* int len = mblen(f, strlen(f)); */
	       int len = strlen(f);

	       if (len > 0) {
		    cpy(len, f);
		    continue;
	       }
	  }
	  
	  if (*f != '%') {
	       add(1, *p = *f);
	       continue;
	  }
	  
	  ++f;
	  switch (*f) {
	  case '%':
	       add(1, *p = *f);
	       break;
	  case 'a':
	       cpy(aw_len, a_wkday);
	       break;
	  case 'A':
	       cpy(wkday_len, f_wkday);
	       break;
	  case 'b':
	       cpy(am_len, a_month);
	       break;
	  case 'B':
	       cpy(month_len, f_month);
	       break;
	  case 'c':
	       subfmt = "%A %B, %d. %Y, %X  %Z";
	  subformat:;
	       {
		    int len = strftime(p, maxsize - i, subfmt, tp);
		    add(len, );
	       }
	       break;
	  case 'd':
	       fmt(2, (p, "%.2d", tp->tm_mday));
	       break;
	  case 'H':
	       fmt(2, (p, "%.2d", tp->tm_hour));
	       break;
	  case 'I':
	       fmt(2, (p, "%.2d", hour12));
	       break;
	  case 'j':
	       fmt(3, (p, "%.3d", tp->tm_yday));
	       break;
	  case 'm':
	       fmt(2, (p, "%.2d", tp->tm_mon + 1));
	       break;
	  case 'M':
	       fmt(2, (p, "%.2d", tp->tm_min));
	       break;
	  case 'p':
	       cpy(ap_len, ampm);
	       break;
	  case 'S':
	       fmt(2, (p, "%.2d", tp->tm_sec));
	       break;
	  case 'U':
	       fmt(2, (p, "%.2u", y_week0));
	       break;
	  case 'w':
	       fmt(2, (p, "%.2d", tp->tm_wday));
	       break;
	  case 'W':
	       fmt(2, (p, "%.2u", y_week1));
	       break;
	  case 'x':
	       subfmt = "%m/%d/%y";
	       goto subformat;
	  case 'X':
	       subfmt = "%H:%M:%S";
	       goto subformat;
	  case 'y':
	       fmt(2, (p, "%.2d", tp->tm_year));
	       break;
	  case 'Y':
	       fmt(4, (p, "%.4d", 1900 + tp->tm_year));
	       break;
	  case 'Z':
	       cpy(zonelen, zone);
	       break;
	  default:
	       /* Bad format.  */
	       break;
	  }
     }
     
     if (p != NULL)
	  *p = '\0';
     return(i);
}
